#ifdef __STDC__
#ifndef __PROTO
#define __PROTO(a) a
#endif
#endif

#ifndef __NOPROTO
#ifndef __PROTO
#define __PROTO(a) a
#endif
#else
#ifndef __PROTO
#define __PROTO(a) ()
#endif
#endif

/* Prototypes for functions defined in ch.c */

int ch_seek __PROTO((register POSITION pos));
int ch_end_seek __PROTO((void));
int ch_beg_seek __PROTO((void));
POSITION ch_length __PROTO((void));
POSITION ch_tell __PROTO((void));
int ch_forw_get __PROTO((void));
int ch_back_get __PROTO((void));
void ch_init __PROTO((int want_nbufs));

/* Prototypes for functions defined in command.c */

void cmd_reset __PROTO((void));
void start_mcc __PROTO((int c));
void commands __PROTO((void));

/* Prototypes for functions defined in help.c */

void help __PROTO((void));

/* Prototypes for functions defined in input.c */

POSITION forw_line __PROTO((POSITION curr_pos));
POSITION back_line __PROTO((POSITION curr_pos));

/* Prototypes for functions defined in io.c */

void ttopen __PROTO((void));
void getrowcol __PROTO((void));
void ttclose __PROTO((void));
int ttgetc __PROTO((void));
int chk_sigs __PROTO((void));
void ttwrite __PROTO((char *buffer,
                     int length));
void ttputs __PROTO((char *s));
#ifdef AMIGA
#define tputs(x,y,z) Tputs(x)
#endif
void Tputs __PROTO((char *s));
int MyRequester __PROTO((char *s));

/* Prototypes for functions defined in line.c */

void prewind __PROTO((void));
int pappend __PROTO((int c));
POSITION forw_raw_line __PROTO((POSITION curr_pos));
POSITION back_raw_line __PROTO((POSITION curr_pos));

/* Prototypes for functions defined in main.c */

void edit __PROTO((register char *filename));
void next_file __PROTO((int n));
void prev_file __PROTO((int n));
int main __PROTO((int argc,
                  char **argv));
void strtcpy __PROTO((char *to,
                     char *from,
                     int len));
void quit __PROTO((void));

/* Prototypes for functions defined in option.c */

void init_option __PROTO((void));
void toggle_option __PROTO((char *s));
void scan_option __PROTO((char *s));

/* Prototypes for functions defined in os.c */

char *glob __PROTO((char *filename));
char *bad_file __PROTO((char *filename,
                        char *message,
                        int len));
char *errno_message __PROTO((char *filename,
                             char *message,
                             int len));

/* Prototypes for functions defined in output.c */

void put_line __PROTO((void));
int control_char __PROTO((int c));
int carat_char __PROTO((int c));
void flush __PROTO((void));
void dropout __PROTO((void));
void putchr __PROTO((int c));
void putstr __PROTO((register char *s));
void error __PROTO((char *s));

/* Prototypes for functions defined in position.c */

POSITION position __PROTO((int where));
void add_forw_pos __PROTO((POSITION pos));
void add_back_pos __PROTO((POSITION pos));
void pos_clear __PROTO((void));
int onscreen __PROTO((POSITION pos));

/* Prototypes for functions defined in prim.c */

void forward __PROTO((int n,
                      int only_last));
void backward __PROTO((int n,
                       int only_last));
void repaint __PROTO((void));
void jump_forw __PROTO((void));
void jump_back __PROTO((register int n));
void jump_percent __PROTO((int percent));
void jump_loc __PROTO((POSITION pos));
void init_mark __PROTO((void));
void setmark __PROTO((int c));
void lastmark __PROTO((void));
void gomark __PROTO((int c));
int get_back_scroll __PROTO((void));
void search __PROTO((int direction,
                     char *pattern,
                     register int n));

/* Prototypes for functions defined in prompt.c */

char *eq_message __PROTO((void));
char *pr_string __PROTO((void));

/* Prototypes for functions defined in screen.c */

void raw_mode __PROTO((int on));
void set_scroll __PROTO((void));
void get_term __PROTO((void));
void init __PROTO((void));
void deinit __PROTO((void));
void home __PROTO((void));
void add_line __PROTO((void));
void lower_left __PROTO((void));
void bell __PROTO((void));
void vbell __PROTO((void));
void clear __PROTO((void));
void clear_eol __PROTO((void));
void so_enter __PROTO((void));
void so_exit __PROTO((void));
void ul_enter __PROTO((void));
void ul_exit __PROTO((void));
void bo_enter __PROTO((void));
void bo_exit __PROTO((void));
void it_enter __PROTO((void));
void it_exit __PROTO((void));
void nv_enter __PROTO((void));
void nv_exit __PROTO((void));
void backspace __PROTO((void));
void putbs __PROTO((void));

/* Prototypes for functions defined in signal.c */

void winch __PROTO((void));
void init_signals __PROTO((void));
void psignals __PROTO((void));

/* Prototypes for functions defined in ttyin.c */

void open_getchr __PROTO((void));
int getchr __PROTO((void));

